/**
 * Beinhaltet die Entscheidungsalgorythmen eines Abwehrspielers.
 */
public class Abwehr extends Spieler {
  /**
   * <b>Konstruktor der Klasse Abwehr</b>.
   * <br><br>
   * n=Spielernummer zwischen 2 und 5<br>
   * welt=Weltmodell des Abwehrspielers
   *
   */
  public Abwehr(int n, Weltmodell welt) {
    super(n, welt);
    }

  /**
   * <b>Trifft die Entscheidung im laufenden Spiel</b>.
   * <br><br>
   * In Schussreichweite sucht der Spieler nach einem Mitspieler, dem er
   * passen kann. War diese Suche erfolgreich, so wird ihm der Ball
   * zugespielt, ansonsten wird Richtung Tor geschossen.
   * <br><br>
   * Ist der Spieler dem Ball selbst am nchsten, nicht aber in Schussreichweite,
   * so rennt der Spieler Richtung Ball.
   * <br><br>
   * Ist ein Mitspieler dem Ball am nchsten, so wird die Methode <i>decken()</i> der
   * Klasse Spieler aufgerufen.
   * <br><br>
   * Ist ein Gegner dem Ball am nchsten, so wird die Methode <i>defense()</i> der
   * Klasse Spieler aufgerufen.
   *
   */
  public String play() {
    if (distance(1,welt.object[0].x, welt.object[0].y)<0.7) {
      int ziel = findPlayerToPass();
      if (ziel != 0) return(Pass(ziel));
      double dir=(direction(1, 52.5, 0)-welt.object[1].direction);
      if (dir>180) dir = dir - 360;
      if (dir<-180) dir= dir+360;
      welt.object[0].xspeed=Math.cos(Math.toRadians(dir));
      welt.object[0].yspeed=Math.sin(Math.toRadians(dir));
      return("(kick 100 "+dir+")");
      }
    if (ToBall[1]<ToBall[nearestTeamPlayer]+5) return(moveToBall());
    if (welt.object[nearestPlayer].team==1) { return(decken()); }
    return(defense());
    }

  /**
   * <b>Trifft die Entscheidung wenn die eigene Mannschaft einen Freistoss hat</b>.
   * <br><br>
   * Diese Methode wird auch bei Ecke, Abstoss oder Einwurf angewand.
   *
   */
  public String ownFree() {
    if (cycle-netz.FreeKickCycle<25) {
      if (nearestTeamPlayer!=1) return(decken());
      if (ToBall[1]>1) return(moveTo(welt.object[0].x-0.5, welt.object[0].y*1.01));
      return(turnToBall());
      }
    if (distance(1,0)<0.5) {
      int ziel = findPlayerToPass();
      if (ziel != 0) return(Pass(ziel));
      double dir;
      if (welt.object[1].y>0) dir=direction(1,0)-welt.object[1].direction;
      else dir=45-welt.object[1].direction;
      if (dir>180) dir = dir - 360;
      if (dir<-180) dir= dir+360;
      welt.object[0].xspeed=2.7*Math.cos(Math.toRadians(dir));
      welt.object[0].yspeed=2.7*Math.sin(Math.toRadians(dir));
      return("(kick 100 "+dir+")");
      }
    if (ToBall[1]<ToBall[nearestTeamPlayer]+5) return(moveToBall());
    return (decken());
    }

  /**
   * <b>Trifft die Entscheidung wenn der Gegner einen Freistoss hat</b>.
   * <br><br>
   * Diese Methode wird auch bei Ecke, Abstoss oder Einwurf angewand.
   *
   */
  public String opponentFree() {
    if (distance(0, areaX, areaY)<30) return(mauer());
    return(decken());
    }
  }