/**
 * Beinhaltet die Entscheidungsalgorythmen eines Mittelfeldspielers.
 */
public class Mittelfeld extends Spieler {
  /**
   * <b>Konstruktor der Klasse Mittelfeld</b>.
   * <br><br>
   * n=Spielernummer zwischen 6 und 9<br>
   * welt=Weltmodell des Abwehrspielers
   *
   */
  Mittelfeld(int n, Weltmodell welt) {
    super(n, welt);
    }

  /**
   * <b>Trifft die Entscheidung im laufenden Spiel</b>.
   * <br><br>
   * Ist der Spieler in Schussreichweite oder am nchsten am Ball
   * wird die Methode <i>offense()</i> der Klasse Spieler aufgerufen.
   * <br><br>
   * Ist ein Gegner dem Ball am nchsten, so wird die Methode <i>defense()</i>
   * der Klasse Spieler aufgerufen.
   * <br><br>
   * Ansonsten wird die Methode <i>freilaufen()</i> der Klasse Spieler
   * aufgerufen.
   *
   */   
  public String play() {
    if (ToBall[1]<ToBall[nearestTeamPlayer]+5) return(offense());
    if (welt.object[nearestPlayer].team==-1) return(defense());
    return(freilaufen());
    }

  /**
   * <b>Trifft die Entscheidung wenn die eigene Mannschaft einen Freistoss hat</b>.
   * <br><br>
   * Diese Methode wird auch bei Ecke, Abstoss oder Einwurf angewand.
   *
   */
  public String ownFree() {
    if (cycle-netz.FreeKickCycle<25) {
      if (nearestTeamPlayer!=1) return(moveTo(areaX, areaY));
      if (ToBall[1]>1) return(moveTo(welt.object[0].x-0.5, welt.object[0].y*1.01));
      return(freilaufen());
      }
    if (ToBall[1]<ToBall[nearestTeamPlayer]+5) return(offense());
    return(freilaufen());
    }

  /**
   * Trifft die Entscheidung wenn der Gegner einen Freistoss hat.
   * <br><br>
   * Diese Methode wird auch bei Ecke, Abstoss oder Einwurf angewand.
   *
   */
  public String opponentFree() {
    if (aussen) return(decken());
    if (distance(0, areaX, areaY)<20) return(mauer());
    return(moveTo(areaX, areaY));
    }
  }