/**
 * <b>Wertet See-Nachricht zu Objekt-Informationen aus</b>.
 * <br><br>
 * Das Weltmodell stellt dem Spieler fr das Treffen der Entscheidung
 * ein aktuelles Weltbild zur verfgung, d.h. es berechnet die eigene
 * absolute Position anhand der Flags auf dem Spielfeld und errechnet
 * die Position von Mitspielern, Ball und Gegnern.<br>
 * Die Daten werden im Array object[] vom Typ MovableObject gespeichert.<br>
 * 	object[0] ist der Ball<br>
 *	object[1] ist der Spieler selbst<br>
 *	object[2-22] sind andere Spieler<br>
 *	object[23-24] sind die Tormittelpunkte<br>
 * Ausserdem sollte das Weltmodell Say-Nachrichten vorbereiten und Hear-
 * Nachrichten von Mitspielern auswerten, die dazu dienen, das Weltbild
 * den Mitspielern mitzuteilen und somit mehr Informationen zu erreichen.
 * Die Implemetierung dieser Methode hat derzeit aber noch schwachstellen,
 * so dass sie im aktuellen Zustand eher zu Nachteilen fhrt und somit
 * nicht eingesetzt wird.
 *
 */
public class Weltmodell {
  int criticalTime; // So lange erinnert er sich an ein Objekt
  /** Spielrichtung */
  public int goalDirection; // Von links nach rechts oder umgekehrt
  double HeadAngle; // Noch nicht genutzt
  /** Name des eigenen Teams */
  public String teamname; // So heit sein Team
  /**
   * Array von Objekten auf dem Spielfeld.
   * <br><br>
   * In diesem Array werden die Informationen, die zur Entscheidungsfindung
   * bentigt werden, gespeichert.<br>
   * object[0]=ball<br>
   * object[1]=Spieler selbst<br>
   * object[2-22]=Andere Spieler<br>
   * object[23-24]=Gegnerisches und eigenes Tor<br>
   */
  public MovableObject object[]=new MovableObject[25]; // Array von MovableObject
  /**
   * <b>Konstruktor der Klasse Weltmodell</b>.
   * <br><br>
   * name=Name der Mannschaft<br>
   * n=Rckennummer des Spielers
   */
  public Weltmodell(String name, int n) {
    teamname=name;
    criticalTime=8;
    goalDirection=1;
    HeadAngle=0.0;
    // Selbst initialisieren
    object[1]=new MovableObject();
    object[1].team=1;
    object[1].number=n;
    // 21 MovableObjects initialisieren
    for (int i=2; i<23; i++) {object[i]=null;}
    // Gegnerischer Tormittelpunkt
    object[23]=new MovableObject();
    object[23].x=52.2; object[23].y=0;
    // Eigener Tormittelpunkt
    object[24]=new MovableObject();
    object[24].x=-52.2; object[24].y=0;
    }

  /**
   * <b>Wertet die See-Nachricht aus</b>.
   * <br><br>
   * Zuerst wird die eigene Position berechnet, dann die aktuelle Position
   * der Objekte aus dem Gedchtnis errechnen, und schlielich die neuen
   * Informationen ber andere Spieler und Ball einfgen.
   *
   */
  public void getSeeFromNet(String s) {
    // Spielfeld, um die nhsten 2 Flags zu ermitteln
    Spielfeld feld = new Spielfeld();
    String daten = s.substring(5, s.length()-1);
    if (daten.indexOf(" ")==-1) {
      update(Integer.decode(daten.substring(0, daten.indexOf(")"))).intValue());
      return;
      }
    int cycle = Integer.decode(daten.substring(0, daten.indexOf(" "))).intValue();
    daten=daten.substring(daten.indexOf(" ")+1);
    String daten2 = "";
    // Flags aus der Nachricht ziehen und ggf. ins Spielfeld eintragen
    while (daten.length()!=0) {
      int zaehler=0;
      int pos=-1;
      while (zaehler<2) {
	if (daten.charAt(++pos)==')') zaehler++;
        }
      // Flags
      if (daten.charAt(2)=='f') fillArray(daten.substring(1, pos), feld);
      if (daten.charAt(2)=='g') fillArray(daten.substring(1, pos), feld);
      // Ball oder Spieler
      if (daten.charAt(2)=='b') daten2 = daten2 + daten.substring(1, pos) + "&";
      if (daten.charAt(2)=='p') daten2 = daten2 + daten.substring(1, pos) + "&";
      if (pos+1<daten.length()) daten=daten.substring(pos+2);
      else daten="";
      }
    // Nur ein Flag reicht nicht zur Auswertung
    if (feld.flagDistance[1]==1000) { update(cycle); return; }
    // Aufruf zur Berechnung der eigenen Position
    if (feld.angle[0]<feld.angle[1]) { getMyPos(feld, 0, 1, cycle); }
    else { getMyPos (feld, 1, 0, cycle); }
    // Neue Postitionen aus dem Gedchtnis errechnen
    update(cycle);
    // Andere Spieler hinzufgen
    while (daten2.length()!=0) {
      objectPos(daten2.substring(0, daten2.indexOf("&")), cycle);
      daten2 = daten2.substring(daten2.indexOf("&")+1);
      }
    }

  /**
   * Wertet die Hear-Nachricht vom Mitspieler aus.
   * Funktion bisher zu mangelhaft
   */
  public void getHearFromNet(String s) {
//    if (object[1].number!=1) { return; }
//    String info=s;
//    int counter=2;
// Message in Daten umwandeln
//    while (info.length()>0) {
// try {
//      double xspeeda=Double.valueOf(info.substring(0, 3)).doubleValue()/100-5;
//      double yspeeda=Double.valueOf(info.substring(3, 6)).doubleValue()/100-5;
//      long temp=Long.valueOf(info.substring(6, info.indexOf("a"))).longValue();
//      int time1a=(int)(temp%6000); temp=temp/6000;
//      int teama=(int)((temp%4)-1); temp=temp/4;
//      int numbera=(int)(temp%12); temp=temp/12;
//      double y1a=((double)(temp%12000))/100-60; temp=temp/12000;
//      double x1a=((double)(temp%12000))/100-60; temp=temp/12000;
//      double richtung;
//      if (object[1].x-x1a==0) {
//        if (y1a>object[1].y) { richtung = 90; }
//        else { richtung=-90; }
//        }
//      if (object[1].x<x1a) { richtung=Math.toDegrees(Math.atan((y1a-object[1].y)/(x1a-object[1].x))); }
//      else { richtung=180+Math.toDegrees(Math.atan((y1a-object[1].y)/(x1a-object[1].x))); }
//      richtung=richtung-object[1].direction-HeadAngle;
//      if (richtung>180)  { richtung = richtung - 360; }
//      if (richtung<-180) { richtung = richtung + 360; }
//      if (Math.abs(richtung)>55) {
//        int spieler=2;
//      while ((spieler<22)&&(object[spieler]!=null)) { spieler++; }
//        insert(x1a, y1a, teama, numbera, time1a, spieler);
//        }
// } catch (NumberFormatException nfe) {}
//      info=info.substring(info.indexOf("a")+1);
//      }
    }

  /**
   * Say/Hear-Nachricht fr Mitspieler vorbereiten.
   * Funktion bisher zu mangelhaft
   */ 
  public String createHearMessage() {
    String message=" ";
//    if (object[0]!=null) {
//      message=message+(int)(100*(object[0].xspeed+5));
//      message=message+(int)(100*(object[0].yspeed+5));
//      long temp=(int)(100*(object[0].x1+60));
//      temp=temp*12000+(int)(100*(object[0].y1+60));
//      temp=temp*12+object[0].number;
//      temp=temp*4+3;
//      temp=temp*6000+object[0].time1;
//      message = message+temp+"a";
//      }
//    if (object[1]!=null) {
//      message=message+(int)(100*(object[1].xspeed+5));
//      message=message+(int)(100*(object[1].yspeed+5));
//      long temp=(int)(100*(object[1].x1+60));
//      temp=temp*12000+(int)(100*(object[1].y1+60));
//      temp=temp*12+object[1].number;
//      temp=temp*4+3;
//      temp=temp*6000+object[1].time1;
//      message = message+temp+"a";
//      }
//    int spieler=2;
//    while ((spieler<23)&&(object[spieler]!=null)) {
//      message=message+(int)(100*(object[spieler].xspeed+5));
//      message=message+(int)(100*(object[spieler].yspeed+5));
//      long temp=(int)(100*(object[spieler].x1+60));
//      temp=temp*12000+(int)(100*(object[spieler].y1+60));
//      temp=temp*12+object[spieler].number;
//      temp=temp*4+object[spieler].team;
//      temp=temp*6000+object[spieler].time1;
//      message = message+temp+"a";
//      spieler++;
//      }
    return message;
    }

  /**
   * <b>Trgt die X/Y-Koordinaten eines Flags in ein Spielfeld ein</b>.
   * <br><br>
   * flag=String mit Flag-Informationen<br>
   * feld=Spielfeld, in das die Koordinaten eingetragen werden
   */
  public void fillArray(String flag, Spielfeld feld) {
    // String entziffern
    String location=flag.substring(1, flag.indexOf(")"));
    flag = flag.substring(flag.indexOf(")")+2);
    // Entfernung zum Flag
    double dist=Double.valueOf(flag.substring(0, flag.indexOf(" "))).doubleValue();
    flag=flag.substring(flag.indexOf(" ")+1);
    // Ende der Flaginfo finden
    int ende=0;
    boolean cond=true;
    while (cond && ende<flag.length()) {
      if ( flag.charAt(ende)==')' || flag.charAt(ende)==' ') cond=false;
      else ende++;
      }
    // relativer Winkel zum Flag
    int angle=Integer.valueOf(flag.substring(0, ende)).intValue();
    // X/Y-Koordinaten finden
    if (dist<=feld.flagDistance[1]) {
	feld.flagDistance[1]=dist;
	feld.angle[1]=angle;
        // goal
	if (location.charAt(0)=='g') {
	  feld.y[1]=0;
	  if (location.charAt(2)=='l') { feld.x[1]=-52.5; }
	  else { feld.x[1]=52.5; }
	  }
	else {
	  // center
	  if (location.charAt(2)=='c') {
	    feld.x[1]=0;
	    if (location.length()==3) { feld.y[1]=0; }
            else {
	      if (location.charAt(4)=='t') { feld.y[1]=-34; }
	      if (location.charAt(4)=='b') { feld.y[1]=34; }
	      }
	    }
	  // goal
	  if (location.charAt(2)=='g') {
	    if (location.charAt(4)=='l') { feld.x[1]=-52.5; }
	    else {feld.x[1]=52.5;}
	    if (location.charAt(6)=='t') { feld.y[1]=-7.01; }
	    else {feld.y[1]=7.01; }
	    }
	  // penalty
	  if (location.charAt(2)=='p') {
	    if (location.charAt(4)=='l') { feld.x[1]=-36; }
	    else { feld.x[1]=36; }
	    if (location.charAt(6)=='t') { feld.y[1]=-20.175; }
	    if (location.charAt(6)=='c') { feld.y[1]=0.0; }
	    if (location.charAt(6)=='b') { feld.y[1]=20.175; }
	    }
	  // top oder bottom
	  if (location.charAt(2)=='t' || location.charAt(2)=='b') {
	    // top
	    if (location.charAt(2)=='t') { feld.y[1]=-39; }
	    // bottom
	    else { feld.y[1]=39; }

	    if (location.charAt(4)=='0') { feld.x[1]=0; }
	    else {
	      int z=1;
	      if (location.charAt(4)=='l') { z=-1; }
	      feld.x[1]=z* Double.valueOf(location.substring(6)).doubleValue();
	      }
	    }
          // left oder right
	  if (location.charAt(2)=='l' || location.charAt(2)=='r') {
	    int z=1;
	    if (location.charAt(2)=='l') { z=-1; }
	    if (location.length()==5) {
	      if (location.charAt(4)=='t') { feld.x[1]=z*52.5; feld.y[1]=-34; }
	      if (location.charAt(4)=='0') { feld.x[1]=z*57.5; feld.y[1]=0; }
	      if (location.charAt(4)=='b') { feld.x[1]=z*52.5; feld.y[1]=34; }
	      }
	    else { 
	      int c=1;
	      if (location.charAt(4)=='t') {c=-1;}
	      feld.x[1]=z*57.5;
	      feld.y[1]=c* Double.valueOf(location.substring(6)).doubleValue();
	      }
	    }
	  }
	}
    // Wenn es zu den 2 nhsten Flags gehrt eintragen
    if (feld.flagDistance[1]<feld.flagDistance[0]) {
      double x,y,f;
      int a;
      x=feld.x[0]; feld.x[0]=feld.x[1]; feld.x[1]=x;
      y=feld.y[0]; feld.y[0]=feld.y[1]; feld.y[1]=y;
      a=feld.angle[0]; feld.angle[0]=feld.angle[1]; feld.angle[1]=a;
      f=feld.flagDistance[0]; feld.flagDistance[0]=feld.flagDistance[1]; feld.flagDistance[1]=f;
      }
    }

  /**
   * <b>Berechnet aus den 2 nchsten Flags die eigene Position</b>.
   * <br><br>
   * feld=Spielfeld, das die Informationen ber die Flags enthlt<br>
   * s=linkes Flag<br>
   * t=rechtes Flag<br>
   * cycle=aktueller Zeitpunkt
   */
  public void getMyPos(Spielfeld feld, int s, int t, int cycle) {
    // absoluter Winkel vom einen Flag zum anderen
    double winkel1=0;
    if (feld.x[t]==feld.x[s]) {
      if (feld.y[t]>feld.y[s]) { winkel1=90; }
      else { winkel1=270; }
      }
    else {
      if (feld.x[s]<feld.x[t]) winkel1=(360+Math.toDegrees(Math.atan((feld.y[t]-feld.y[s])/(feld.x[t]-feld.x[s]))))%360;
      if (feld.x[s]>feld.x[t]) winkel1= 180+Math.toDegrees(Math.atan((feld.y[t]-feld.y[s])/(feld.x[t]-feld.x[s])));
      }
    // Innenwinkel zwischen Spieler und  zwei Flags
    double a=feld.flagDistance[t];
    double b=Math.sqrt((feld.x[s]-feld.x[t])*(feld.x[s]-feld.x[t])+(feld.y[s]-feld.y[t])*(feld.y[s]-feld.y[t]));
    double c=feld.flagDistance[s];
    // absoluter Winkel zwischen relativem linkem Flag und Spieler
    double winkel2;
    if (a+b<=c) { // Wenn zu grob gerundet Ausnahme
      winkel2=winkel1;
      }
    else {
      if (b+c<=a) { // Wenn zu grob gerundet Ausnahme
        winkel2=(winkel1+180)%360;
        }
      else {
        if (a+c<=b) { // Wenn zu grob gerundet Ausnahme
        winkel2=(winkel1+180)%360;
	  }
        else {
	  // Cosinus-Satz
	  winkel2=(winkel1+Math.toDegrees(Math.acos((b*b+c*c-a*a)/(2*b*c))))%360;
	  }
        }
      }
    // aus winkel2 und Entfernung zum linken Flag die X/Y-Coordinaten errechnen
    object[1].x=goalDirection*(feld.x[s]+Math.cos(Math.toRadians(winkel2))*feld.flagDistance[s]);
    object[1].y=goalDirection*(feld.y[s]+Math.sin(Math.toRadians(winkel2))*feld.flagDistance[s]);
    object[1].direction=(90+90*goalDirection+winkel2-feld.angle[s]-HeadAngle)%360;
    // Spielerrichtung
    if (object[1].direction>180) object[1].direction = object[1].direction-360;
    // Spielergeschwindigkeit
    if (object[1].time1 != cycle) {
      object[1].xspeed=(object[1].x-object[1].x1)/(cycle-object[1].time1);
      object[1].yspeed=(object[1].y-object[1].y1)/(cycle-object[1].time1);
      }
    // Ort der letzten "sicheren" Information festlegen
    object[1].x1=object[1].x;
    object[1].y1=object[1].y;
    // Zeit der letzten aktualisierung festlegen
    object[1].time1=cycle;
    }

  /**
   * <b>Aktuelle Position von anderen Spielern aus dem Gedchtnis errechnen</b>.
   * <br><br>
   * cycle=Zeitpunkt, zu dem die neuen Koordinaten berechnet werden sollen.
   */
  public void update(int cycle) {
    // Ball
    if (object[0]!=null) {
      if (cycle-object[0].time1>criticalTime) {
	object[0]=null;
        }
      else { 
	if (cycle>object[0].time1) {
	  object[0].x=object[0].x1+(object[0].xspeed/0.06)*(1-potenz(0.94, cycle-object[0].time1));
	  object[0].y=object[0].y1+(object[0].yspeed/0.06)*(1-potenz(0.94, cycle-object[0].time1));
	  }
	}
      }
    // Wenn Erinnerung zu alt, Spieler aus Gedchtnis lschen
    int spieler=2;
    while ((spieler<23)&&(object[spieler]!=null))
      {
      if (cycle-object[spieler].time1>criticalTime) {
	int i=spieler;
        while ((i<22)&&(object[i+1]!=null)) {
	  object[i]=object[i+1];
	  i++;
	  }
        object[i]=null;
	}
      spieler++;
      }
    // aktuelle Positionen errechnen
    spieler=1;
    while ((spieler<23)&&(object[spieler]!=null))
      {
      if (object[spieler].time1 < cycle) {
	object[spieler].x = object[spieler].x1+(object[spieler].xspeed/0.6)*(1-potenz(0.6, cycle-object[spieler].time1));
	object[spieler].y = object[spieler].y1+(object[spieler].yspeed/0.6)*(1-potenz(0.6, cycle-object[spieler].time1));
	}
      spieler++;
      }
    }

  /**
   * <b>Berechnet die absolute Position der anderen Objekte</b>.
   * <br><br>
   * temp=String mit Informationen ber die Objekte<br>
   * cycle=Zeitpunkt des Eintrags
   */
  public void objectPos(String temp, int cycle) {
    String daten=temp;
    // Spieler
    if (daten.charAt(1)=='p') {
      int Team=0;
      int Number=0;
      double Distance;
      double Direction;
      // Informationen ber Spieler
      String playerInfo = daten.substring(1, daten.indexOf(")"))+" ";
      if (playerInfo.length()>2) {
        playerInfo=playerInfo.substring(3);
        if (playerInfo.substring(0, playerInfo.indexOf(" ")-1).equals(teamname)) { Team=1; }
        else {
	  if ((playerInfo.substring(0, playerInfo.indexOf(" ")-1).equals(""))==false) { Team=-1; }
	  }
        playerInfo=playerInfo.substring(playerInfo.indexOf(" ")+1);
        if (playerInfo.length()!=0) { Number=Integer.decode(playerInfo.substring(0, playerInfo.indexOf(" "))).intValue(); }
	}
      // Ort des Spielers
      daten=daten.substring(daten.indexOf(")")+2)+" ";
      Direction=Double.valueOf(daten.substring(0, daten.indexOf(" "))).doubleValue();
      if (daten.length()<daten.indexOf(" ")+2) { return; }
      daten=daten.substring(daten.indexOf(" ")+1);
      Distance=Direction;
      Direction=Double.valueOf(daten.substring(0, daten.indexOf(" "))).doubleValue();
      Direction=(object[1].direction+HeadAngle+Direction)%360;
      double objx=object[1].x+Math.cos(Math.toRadians(Direction))*Distance;
      double objy=object[1].y+Math.sin(Math.toRadians(Direction))*Distance;
      // Spieler eintragen
      int spieler;
      // Team und Nummer des Spielers bekannt
      if ((Team!=0)&&(Number!=0)) {
        spieler = 2;
        while((spieler<23)&&(object[spieler]!=null)) {
	  if ((object[spieler].team==Team)&&(object[spieler].number==Number)) {
	    insert(objx, objy, Team, Number, cycle, spieler);
	    return;
	    }
	  spieler++;
	  }
        }
      // Spielerinformationen unbekannt
      // Nhsten Spieler suchen
      spieler=2;
      int nearestPlayer=0;
      double nearestDistance=1000;
      while((spieler<23)&&(object[spieler]!=null)) {
        if (((Team==0)||(object[spieler].team==Team))&&(object[spieler].time1<cycle)) {
          double E=Math.sqrt((object[spieler].x-objx)*(object[spieler].x-objx)+(object[spieler].y-objy)*(object[spieler].y-objy));
          if (E<nearestDistance) {
            nearestPlayer=spieler;
            nearestDistance=E;
            }
          }
        spieler++;          
        }
      // Wenn es einen Spieler gibt, der nah genug am neuen Objekt ist 
      if ((nearestPlayer!=0)&&(nearestDistance<2*(cycle-object[nearestPlayer].time1))) {
        insert(objx, objy, Team, Number, cycle, nearestPlayer);
        return;
        }
      // Wenn es keinen solchen Spieler gibt
      insert(objx, objy, Team, Number, cycle, 23);
      return;
      }
    // Ballposition
    if (daten.charAt(1)=='b') {
      if (object[0]==null) { object[0]= new MovableObject(); }
      daten = daten.substring(daten.indexOf(")")+2);
      // Entfernung zum Ball
      double dist=Double.valueOf(daten.substring(0, daten.indexOf(" "))).doubleValue();
      daten=daten.substring(daten.indexOf(" ")+1);
      int ende=0;
      boolean cond=true;
      while (cond && ende<daten.length()) {
        if ( daten.charAt(ende)==' ') cond=false;
        else ende++;
        }
      // Winkel zum Ball
      double angle=Double.valueOf(daten.substring(0, ende)).doubleValue();
      angle=(object[1].direction+HeadAngle+angle)%360;
      // Neue Ballposition eintragen
      object[0].x=object[1].x+Math.cos(Math.toRadians(angle))*dist;
      object[0].y=object[1].y+Math.sin(Math.toRadians(angle))*dist;
      // Ballgeschwindigkeit errechnen
      if (object[0].time1 != cycle) {
        object[0].xspeed=(object[0].x-object[0].x1)/(cycle-object[0].time1);
        object[0].yspeed=(object[0].y-object[0].y1)/(cycle-object[0].time1);
	}
      // Ort der letzten "sicheren" Information festlegen
      object[0].x1=object[0].x;
      object[0].y1=object[0].y;
      // Zeitpunkt der letzten "sicheren" Information setzen
      object[0].time1=cycle;
      }
    }

  /**
   * Hilfs-Methode zur Berechnung einer Potenz.
   * <br><br>
   * x=Basis<br>
   * y=Exponent
   */
  public double potenz(double x, int y)
    {
    if (y==1) { return x; }
    else { return potenz(x,y-1)*x; }
    }

  /**
   * <b>Trgt die Spielerdaten in das MovableObject ein</b>.
   * <br><br>
   * objx=X-Koordinate des Objekts<br>
   * objy=Y-Koordinate des Objekts<br>
   * Team=Angehrigkeit des Spielers [-1,0,1]<br>
   * Number=Rckennummer des Spielers<br>
   * cycle=Zeitpunkts des Eintrags<br>
   * pos=Position im Array, an der das Objekt eingetragen wird
   */
  public void insert(double objx, double objy, int Team, int Number, int cycle, int pos) {
    // Wenn Array voll, ltesten Eintrag lschen
    if (pos>22) {
        int zeit=10000;
	double entfernung=1000;
	int p;
	int spieler=2;
	while(spieler<23) {
	  if (object[spieler]==null) { pos=spieler; spieler=23;}
	  else {
	    if (object[spieler].time1<=zeit) {
	      double E1=Math.sqrt((object[spieler].x-objx)*(object[spieler].x-objx)+(object[spieler].y-objy)*(object[spieler].y-objy));
	      if ((object[spieler].time1==zeit)&&(E1<entfernung)) {
		entfernung=E1;
		pos=spieler;
		}
	      if (object[spieler].time1<zeit) {
		zeit=object[spieler].time1;
		entfernung=E1;
		pos=spieler;
		}
	      }        
	    }
	  spieler++;
	  }
        object[pos]=null;
	}
    // Wenn es ein neues Objekt ist
    if (object[pos]==null) {
      object[pos]= new MovableObject();
      object[pos].x1=objx;
      object[pos].y1=objy;
      object[pos].time1=cycle;
      }
    // Koordinaten eintragen
    object[pos].x=objx;
    object[pos].y=objy;
    // Geschwindigkeit errechnen
    if (object[pos].time1!=cycle) {
        object[pos].xspeed=(object[pos].x-object[pos].x1)/(cycle-object[pos].time1);
        object[pos].yspeed=(object[pos].y-object[pos].y1)/(cycle-object[pos].time1);
        object[pos].time1=cycle;
      }
    // Ort der letzten "sicheren" Information festlegen
    object[pos].x1=objx;
    object[pos].y1=objy;
    // Spielerinformationen eintragen
    if (Team!=0) { object[pos].team=Team; }
    if (Number!=0) { object[pos].number=Number; }
    }
}

